diff --git a/src/main/java/net/minecraft/core/world/AuroraProvider.java b/src/main/java/net/minecraft/core/world/AuroraProvider.java
index d81e4ab17..edf9f0ce0 100644
--- a/src/main/java/net/minecraft/core/world/AuroraProvider.java
+++ b/src/main/java/net/minecraft/core/world/AuroraProvider.java
@@ -15,12 +15,12 @@ public class AuroraProvider
         noise = new ImprovedNoise(new Random(seed));
     }
 
-    public float getAuroraPresence(float x, float z, long worldTime, float celestialAngle)
+    public double getAuroraPresence(double x, double z, long worldTime, float celestialAngle)
     {
-        float auroraLevel = 0.0f;
-        float auroraRadius = 0.03f;
+        double auroraLevel = 0.0f;
+        double auroraRadius = 0.03f;
 
-        float mult = 1.0f;
+        double mult = 1.0d;
         if (celestialAngle < 0.25f || celestialAngle > 0.75f)
         {
             return 0.0f;
@@ -39,8 +39,8 @@ public class AuroraProvider
             mult = celestialAngle;
         }
 
-        float sample = (float)noise.getValue(x / 1000, worldTime / 5000f, z / 1000);
-        sample += (float)noise.getValue(x / 30, worldTime / 50f, z / 30) * 0.05f;
+        double sample = noise.getValue(x / 1000d, worldTime / 5000d, z / 1000d);
+        sample += noise.getValue(x / 30d, worldTime / 50d, z / 30d) * 0.05d;
         if (sample < auroraLevel - auroraRadius || sample > auroraLevel + auroraRadius)
         {
             return 0.0f;
@@ -56,50 +56,49 @@ public class AuroraProvider
             // Range = 1.0 to 0.0 to 1.0
             sample = -sample;
             // Range = -1.0 to 0.0 to -1.0
-            sample += 1.0f;
+            sample += 1.0d;
             // Range = 0.0 to 1.0 to 0.0
             return sample * mult;
         }
     }
 
-    public float getAuroraHeightOffset(float x, float z, float worldTime)
+    public double getAuroraHeightOffset(double x, double z, double worldTime)
     {
-        float sample = (float)noise.getValue(x / 100, worldTime / 5000, z / 100) * 25;
-        return sample;
+        return noise.getValue(x / 100d, worldTime / 5000d, z / 100d) * 25d;
     }
 
-    public float getAuroraRedOffset(float x, float z, float worldTime)
+    public float getAuroraRedOffset(double x, double z, double worldTime)
     {
-        float sample = (float)noise.getValue(x / 500, worldTime / 5000 + 10000, z / 500);
-        float sample2 = (float)noise.getValue(x / 200, worldTime / 5000, z / 200);
+        double sample = noise.getValue(x / 500d, worldTime / 5000d + 10000, z / 500d);
+        double sample2 = noise.getValue(x / 200d, worldTime / 5000d, z / 200d);
         if (sample < 0.0f) sample = 0.0f;
         if (sample > 0.25f) sample = 0.25f;
         if (sample2 < 0.0f) sample2 = 0.0f;
         if (sample2 > 0.1f) sample2 = 0.1f;
 
 
-        return sample * 3 + sample2 * 2;
+        return (float) (sample * 3 + sample2 * 2);
     }
 
-    public float getAuroraGreenOffset(float x, float z, float worldTime)
+    public float getAuroraGreenOffset(double x, double z, double worldTime)
     {
-        float sample = (float)noise.getValue(x / 500, worldTime / 5000 + 10000, z / 500);
-        float sample2 = (float)noise.getValue(x / 500, worldTime / 5000, z / 500);
+        double sample = noise.getValue(x / 500d, worldTime / 5000d + 10000d, z / 500d);
+        double sample2 = noise.getValue(x / 500d, worldTime / 5000d, z / 500d);
         if (sample < 0) sample = 0;
         if (sample > 0.125f) sample = 0.125f;
         if (sample2 < 0.0f) sample2 = 0.0f;
         if (sample2 > 0.25f) sample2 = 0.25f;
 
 
-        return sample * 4 - sample2 * 2;
+        return (float) (sample * 4 - sample2 * 2);
     }
 
-    public float getAuroraBlueOffset(float x, float z, float worldTime)
+    public float getAuroraBlueOffset(double x, double z, double worldTime)
     {
-        float sample = (float)noise.getValue(x / 500, worldTime / 5000, z / 500);
+        double sample = noise.getValue(x / 500d, worldTime / 5000d, z / 500d);
         if (sample < 0.0f) sample = 0.0f;
         if (sample > 0.25f) sample = 0.25f;
 
-        return sample;
+        return (float) sample;
     }
 }
diff --git a/src/main/java/net/minecraft/core/world/SpawnerMobs.java b/src/main/java/net/minecraft/core/world/SpawnerMobs.java
index 386746d05..6ea3c8e13 100644
--- a/src/main/java/net/minecraft/core/world/SpawnerMobs.java
+++ b/src/main/java/net/minecraft/core/world/SpawnerMobs.java
@@ -1,15 +1,20 @@
 package net.minecraft.core.world;
 
+import net.minecraft.core.block.BlockBed;
+import net.minecraft.core.block.material.Material;
 import net.minecraft.core.data.gamerule.GameRules;
-import net.minecraft.core.entity.*;
-import net.minecraft.core.entity.monster.*;
+import net.minecraft.core.entity.EntityLiving;
+import net.minecraft.core.entity.SpawnListEntry;
+import net.minecraft.core.entity.monster.EntityArmoredZombie;
+import net.minecraft.core.entity.monster.EntitySkeleton;
+import net.minecraft.core.entity.monster.EntitySpider;
+import net.minecraft.core.entity.monster.EntityZombie;
 import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumCreatureType;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.Vec3d;
 import net.minecraft.core.world.biome.Biome;
-import net.minecraft.core.block.BlockBed;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkCoordinate;
 import net.minecraft.core.world.chunk.ChunkCoordinates;
 import net.minecraft.core.world.chunk.ChunkPosition;
@@ -18,18 +23,8 @@ import net.minecraft.core.world.pathfinder.Path;
 import net.minecraft.core.world.pathfinder.PathFinder;
 
 import java.util.HashSet;
-import java.util.Iterator;
 import java.util.List;
 import java.util.Set;
-
-
-// Referenced classes of package net.minecraft.src:
-//            World, ChunkPosition, EntityPlayer, MathHelper, 
-//            ChunkCoordIntPair, EnumCreatureType, WorldChunkManager, BiomeGenBase, 
-//            SpawnListEntry, ChunkCoordinates, EntityLiving, Material, 
-//            EntitySpider, EntitySkeleton, EntitySheep, Pathfinder, 
-//            PathEntity, PathPoint, BlockBed, EntityZombie
-
 public final class SpawnerMobs
 {
 
@@ -37,165 +32,155 @@ public final class SpawnerMobs
     {
     }
 
-    private static ChunkPosition getRandomSpawningPointInChunk(World world, int i, int j)
+    private static ChunkPosition getRandomSpawningPointInChunk(World world, int x, int z)
     {
-        int k = i + world.rand.nextInt(16);
-        int l = world.rand.nextInt(world.getHeightBlocks());
-        int i1 = j + world.rand.nextInt(16);
-        return new ChunkPosition(k, l, i1);
+        int newX = x + world.rand.nextInt(16);
+        int newY = world.rand.nextInt(world.getHeightBlocks());
+        int newZ = z + world.rand.nextInt(16);
+        return new ChunkPosition(newX, newY, newZ);
     }
 
     public static int performSpawning(World world, boolean spawnHostileMobs, boolean spawnPassiveMobs)
     {
-        if(!spawnHostileMobs && !spawnPassiveMobs)
-        {
-            return 0;
+        if(!spawnHostileMobs && !spawnPassiveMobs) { return 0; }
+        eligibleChunksForSpawning.clear();
+
+        for (EntityPlayer player : world.players){
+            final int playerChunkX = MathHelper.floor_double(player.x / Chunk.CHUNK_SIZE_X);
+            final int playerChunkZ = MathHelper.floor_double(player.z / Chunk.CHUNK_SIZE_Z);
+            final byte spawnRadius = 8;
+
+            for(int dx = -spawnRadius; dx <= spawnRadius; ++dx) {
+                for(int dz = -spawnRadius; dz <= spawnRadius; ++dz) {
+                    if(world.isChunkLoaded(dx + playerChunkX, dz + playerChunkZ)) {
+                        eligibleChunksForSpawning.add(new ChunkCoordinate(dx + playerChunkX, dz + playerChunkZ));
+                    }
+                }
+            }
         }
-        else
-        {
-            eligibleChunksForSpawning.clear();
 
-            int playerIndex;
-            for(playerIndex = 0; playerIndex < world.players.size(); ++playerIndex)
-            {
-                EntityPlayer player = world.players.get(playerIndex);
-                int playerChunkX = MathHelper.floor_double(player.x / 16.0D);
-                int playerChunkZ = MathHelper.floor_double(player.z / 16.0D);
-                byte spawnRadius = 8;
+        int totalSpawned = 0;
+        final ChunkCoordinates spawnChunk = world.getSpawnPoint();
+        final ChunkCoordinate[] spawnChunks = new ChunkCoordinate[3 * 3];
+        for (int x = 0; x < 3; x++) {
+            for (int z = 0; z < 3; z++) {
+                spawnChunks[x * 3 + z] = new ChunkCoordinate(spawnChunk.x + (x - 1), spawnChunk.z + (z - 1));
+            }
+        }
 
-                for(int dx = -spawnRadius; dx <= spawnRadius; ++dx)
-                {
-                    for(int dz = -spawnRadius; dz <= spawnRadius; ++dz)
-                    {
-                    	if(world.isChunkLoaded(dx + playerChunkX, dz + playerChunkZ)) {
-                    		eligibleChunksForSpawning.add(new ChunkCoordinate(dx + playerChunkX, dz + playerChunkZ));
-                    	}
+
+        for (EnumCreatureType creatureType : EnumCreatureType.values()) {
+
+            if (creatureType.getPeacefulCreature() && !spawnPassiveMobs) continue;
+            if (!creatureType.getPeacefulCreature() && !spawnHostileMobs) continue;
+            if (world.countEntities(creatureType.getCreatureClass()) > ((creatureType.getMaxNumberOfCreature() * eligibleChunksForSpawning.size()) / 256))
+                continue;
+
+            for (ChunkCoordinate chunk : eligibleChunksForSpawning) {
+                boolean checkSpawnDist = false;
+                for (ChunkCoordinate c : spawnChunks){
+                    if (c.equals(chunk)){
+                        checkSpawnDist = true;
+                        break;
                     }
                 }
-            }
 
-            playerIndex = 0;
-            ChunkCoordinates spawnChunk = world.getSpawnPoint();
-            EnumCreatureType[] creatureTypes = EnumCreatureType.values();
+                final int blockX = chunk.x * Chunk.CHUNK_SIZE_X;
+                final int blockZ = chunk.z * Chunk.CHUNK_SIZE_Z;
+                final Biome biome = world.getBlockBiome(blockX, world.getHeightBlocks() - 1, blockZ);
+                final List<SpawnListEntry> spawnableList = biome.getSpawnableList(creatureType);
 
-            for(int i = 0; i < creatureTypes.length; ++i)
-            {
-                EnumCreatureType creatureType = creatureTypes[i];
-                if((!creatureType.getPeacefulCreature() || spawnPassiveMobs) && (creatureType.getPeacefulCreature() || spawnHostileMobs) && world.countEntities(creatureType.getCreatureClass()) <= creatureType.getMaxNumberOfCreature() * eligibleChunksForSpawning.size() / 256)
-                {
-                    Iterator<ChunkCoordinate> chunkIt = eligibleChunksForSpawning.iterator();
+                if (spawnableList == null) continue;
+                if (spawnableList.isEmpty()) continue;
 
-                    label113:
-                    while(chunkIt.hasNext())
-                    {
-                        ChunkCoordinate chunk = chunkIt.next();
-                        Biome biome = world.getBlockBiome(chunk.x * 16, world.getHeightBlocks() - 1, chunk.z * 16);
-                        List<SpawnListEntry> spawnableList = biome.getSpawnableList(creatureType);
-                        if(spawnableList != null && !spawnableList.isEmpty())
-                        {
-                            int totalSpawnRarity = 0;
+                int totalSpawnRarity = 0;
 
-                            SpawnListEntry spawnListEntry;
-                            for (SpawnListEntry listEntry : spawnableList)
-                            {
-                                totalSpawnRarity += listEntry.spawnFrequency;
-                            }
+                SpawnListEntry spawnListEntry;
+                for (SpawnListEntry listEntry : spawnableList) {
+                    totalSpawnRarity += listEntry.spawnFrequency;
+                }
 
-                            int calculatedSpawnChance = world.rand.nextInt(totalSpawnRarity);
-                            spawnListEntry = spawnableList.get(0);
+                int calculatedSpawnChance = world.rand.nextInt(totalSpawnRarity);
+                spawnListEntry = spawnableList.get(0);
 
-                            for (SpawnListEntry listEntry : spawnableList)
-                            {
-                                calculatedSpawnChance -= listEntry.spawnFrequency;
-                                if (calculatedSpawnChance < 0)
-                                {
-                                    spawnListEntry = listEntry;
-                                    break;
-                                }
-                            }
-
-                            ChunkPosition pos = getRandomSpawningPointInChunk(world, chunk.x * 16, chunk.z * 16);
-                            int x = pos.x;
-                            int y = pos.y;
-                            int z = pos.z;
-                            if(!world.isBlockNormalCube(x, y, z) && world.getBlockMaterial(x, y, z) == creatureType.getCreatureMaterial())
-                            {
-                                int countSpawned = 0;
-
-                                for(int tryToSpawnX = 0; tryToSpawnX < 3; ++tryToSpawnX)
-                                {
-                                    int ix = x;
-                                    int iy = y;
-                                    int iz = z;
-                                    byte range = 6;
-
-                                    for(int tryToSpawnZ = 0; tryToSpawnZ < 4; ++tryToSpawnZ)
-                                    {
-                                        ix += world.rand.nextInt(range) - world.rand.nextInt(range);
-                                        iy += world.rand.nextInt(2) - world.rand.nextInt(2);
-                                        iz += world.rand.nextInt(range) - world.rand.nextInt(range);
-                                        if(canCreatureTypeSpawnAtLocation(creatureType, world, ix, iy, iz))
-                                        {
-                                            float dx = (float)ix + 0.5F;
-                                            float dy = (float)iy;
-                                            float dz = (float)iz + 0.5F;
-                                            if(world.getClosestPlayer(dx, dy, dz, 24.0D) == null)
-                                            {
-                                                float spawnDistanceX = dx - (float)spawnChunk.x;
-                                                float spawnDistanceY = dy - (float)spawnChunk.y;
-                                                float spawnDistanceZ = dz - (float)spawnChunk.z;
-                                                float spawnDistanceSquared = spawnDistanceX * spawnDistanceX + spawnDistanceY * spawnDistanceY + spawnDistanceZ * spawnDistanceZ;
-                                                if(spawnDistanceSquared >= 576.0F)
-                                                {
-                                                    EntityLiving mobToSpawn;
-
-                                                    try
-                                                    {
-                                                        mobToSpawn = (EntityLiving)spawnListEntry.entityClass.getConstructor(new Class[]{World.class}).newInstance(new Object[]{world});
-                                                    }
-                                                    catch (Exception e)
-                                                    {
-                                                        e.printStackTrace();
-                                                        return playerIndex;
-                                                    }
-
-                                                    mobToSpawn.moveTo(dx, dy, dz, world.rand.nextFloat() * 360.0F, 0.0F);
-                                                    if(mobToSpawn.getCanSpawnHere())
-                                                    {
-
-                                                        ++countSpawned;
-                                                        mobToSpawn.spawnInit();
-                                                        world.entityJoinedWorld(mobToSpawn);
-                                                        if(countSpawned >= mobToSpawn.getMaxSpawnedInChunk())
-                                                        {
-                                                            continue label113;
-                                                        }
-                                                    }
-
-                                                    playerIndex += countSpawned;
-                                                }
-                                            }
-                                        }
-                                    }
-                                }
-                            }
+                for (SpawnListEntry listEntry : spawnableList) {
+                    calculatedSpawnChance -= listEntry.spawnFrequency;
+                    if (calculatedSpawnChance < 0) {
+                        spawnListEntry = listEntry;
+                        break;
+                    }
+                }
+
+                final ChunkPosition pos = getRandomSpawningPointInChunk(world, blockX, blockZ);
+                final int x = pos.x;
+                final int y = pos.y;
+                final int z = pos.z;
+                if (/*world.isBlockNormalCube(x, y, z) || */world.getBlockMaterial(x, y, z) != creatureType.getCreatureMaterial())
+                    continue;
+
+                int countSpawned = 0;
+
+                final byte range = 6;
+
+                for (int i = 0; i < 3; i++) {
+                    int ix = x;
+                    int iy = y;
+                    int iz = z;
+                    for (int spawnAttempt = 0; spawnAttempt < 4; ++spawnAttempt) {
+                        ix += world.rand.nextInt(range) - world.rand.nextInt(range);
+                        iy += world.rand.nextInt(2) - world.rand.nextInt(2);
+                        iz += world.rand.nextInt(range) - world.rand.nextInt(range);
+                        if (!canCreatureTypeSpawnAtLocation(creatureType, world, ix, iy, iz)) continue;
+
+                        final double dx = ix + 0.5D;
+                        final double dy = iy;
+                        final double dz = iz + 0.5D;
+                        if (world.getClosestPlayer(dx, dy, dz, 24.0D) != null) continue;
+
+                        // Forbid mob spawning in a 24 block radius around spawn
+                        if (checkSpawnDist) {
+                            final double spawnDistanceX = dx - spawnChunk.x;
+                            final double spawnDistanceY = dy - spawnChunk.y;
+                            final double spawnDistanceZ = dz - spawnChunk.z;
+                            final double spawnDistanceSquared = spawnDistanceX * spawnDistanceX + spawnDistanceY * spawnDistanceY + spawnDistanceZ * spawnDistanceZ;
+                            if (spawnDistanceSquared < 576.0F) continue;
+                        }
+
+                        EntityLiving mobToSpawn;
+                        try {
+                            mobToSpawn = (EntityLiving) spawnListEntry.entityClass.getConstructor(new Class[]{World.class}).newInstance(new Object[]{world});
+                        } catch (Exception e) {
+                            new RuntimeException("Error spawning entity class '" + spawnListEntry.entityClass.getSimpleName() + "' class missing default constructor for World! Skipping spawn attempt!", e).printStackTrace();
+                            return totalSpawned;
+                        }
+
+                        mobToSpawn.moveTo(dx, dy, dz, world.rand.nextFloat() * 360.0F, 0.0F);
+                        if (!mobToSpawn.getCanSpawnHere()) {
+                            continue;
+                        }
+
+                        ++countSpawned;
+                        mobToSpawn.spawnInit();
+                        world.entityJoinedWorld(mobToSpawn);
+                        if (countSpawned >= mobToSpawn.getMaxSpawnedInChunk()) {
+                            break;
                         }
                     }
                 }
+                totalSpawned += countSpawned;
             }
-
-            return playerIndex;
         }
+        return totalSpawned;
     }
 
-    private static boolean canCreatureTypeSpawnAtLocation(EnumCreatureType enumcreaturetype, World world, int i, int j, int k)
+    private static boolean canCreatureTypeSpawnAtLocation(EnumCreatureType enumcreaturetype, World world, int x, int y, int z)
     {
         if(enumcreaturetype.getCreatureMaterial() == Material.water)
         {
-            return world.getBlockMaterial(i, j, k).isLiquid() && !world.isBlockNormalCube(i, j + 1, k);
+            return world.getBlockMaterial(x, y, z).isLiquid() && !world.isBlockNormalCube(x, y + 1, z);
         } else
         {
-            return world.isBlockNormalCube(i, j - 1, k) && !world.isBlockNormalCube(i, j, k) && !world.getBlockMaterial(i, j, k).isLiquid();
+            return world.isBlockNormalCube(x, y - 1, z) && !world.isBlockNormalCube(x, y, z) && !world.getBlockMaterial(x, y, z).isLiquid();
         }
     }
 
